/*********************************************************************************************************
*
* File                : main.c
* Hardware Environment: 
* Build Environment   : RealView MDK-ARM  Version: 4.20
* Version             : V1.0
* By                  : 
*
*                                  (c) Copyright 2005-2011, WaveShare
*                                       http://www.waveshare.net
*                                          All Rights Reserved
*
*********************************************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "stm32f10x.h"
#include <stdio.h>
#include <string.h>

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/

/* Private function prototypes -----------------------------------------------*/
#ifdef __GNUC__
/* With GCC/RAISONANCE, small printf (option LD Linker->Libraries->Small printf
   set to 'Yes') calls __io_putchar() */
#define PUTCHAR_PROTOTYPE int __io_putchar(int ch)
#else
#define PUTCHAR_PROTOTYPE int fputc(int ch, FILE *f)
#endif /* __GNUC__ */

#define KEY1_Port						GPIOB
#define KEY1_Pin						GPIO_Pin_13
#define KEY1_RCC_APB2Periph				RCC_APB2Periph_GPIOB
/****************************************************************/
#define KEY2_Port						GPIOB
#define KEY2_Pin						GPIO_Pin_14
#define KEY2_RCC_APB2Periph				RCC_APB2Periph_GPIOB
/****************************************************************/
#define KEY3_Port						GPIOB
#define KEY3_Pin						GPIO_Pin_15
#define KEY3_RCC_APB2Periph				RCC_APB2Periph_GPIOB
/****************************************************************/
#define JOY_A_KEY_Port					GPIOD
#define JOY_A_KEY_Pin					GPIO_Pin_8
#define JOY_A_KEY_RCC_APB2Periph		RCC_APB2Periph_GPIOD

#define JOY_B_KEY_Port					GPIOD
#define JOY_B_KEY_Pin					GPIO_Pin_9
#define JOY_B_KEY_RCC_APB2Periph		RCC_APB2Periph_GPIOD

#define JOY_C_KEY_Port					GPIOD
#define JOY_C_KEY_Pin					GPIO_Pin_10
#define JOY_C_KEY_RCC_APB2Periph		RCC_APB2Periph_GPIOD

#define JOY_D_KEY_Port					GPIOD
#define JOY_D_KEY_Pin					GPIO_Pin_11
#define JOY_D_KEY_RCC_APB2Periph		RCC_APB2Periph_GPIOD

#define JOY_CTR_KEY_Port				GPIOD
#define JOY_CTR_KEY_Pin					GPIO_Pin_12
#define JOY_CTR_KEY_RCC_APB2Periph		RCC_APB2Periph_GPIOD 
/****************************************************************/
#define LED1_Port						GPIOE
#define LED1_Pin						GPIO_Pin_7
#define LED1_RCC_APB2Periph				RCC_APB2Periph_GPIOE

#define LED2_Port						GPIOE
#define LED2_Pin						GPIO_Pin_8
#define LED2_RCC_APB2Periph				RCC_APB2Periph_GPIOE

#define LED3_Port						GPIOE
#define LED3_Pin						GPIO_Pin_9
#define LED3_RCC_APB2Periph				RCC_APB2Periph_GPIOE

#define LED4_Port						GPIOE
#define LED4_Pin						GPIO_Pin_10
#define LED4_RCC_APB2Periph				RCC_APB2Periph_GPIOE


void GPIO_Configuration(void);
void  Delay (uint32_t nCount);

/* Private functions ---------------------------------------------------------*/

/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{
  /*!< At this stage the microcontroller clock setting is already configured, 
       this is done through SystemInit() function which is called from startup
       file (startup_stm32f10x_xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_stm32f10x.c file
     */     

  /* Add your application code here
     */
	uint8_t key=0;

	GPIO_Configuration();
	/* Infinite loop */
  while (1)
	{
		if(!GPIO_ReadInputDataBit(KEY1_Port,KEY1_Pin))
			key=1;
		else if(!GPIO_ReadInputDataBit(KEY2_Port,KEY2_Pin))
			key=2;
		else if(!GPIO_ReadInputDataBit(KEY3_Port,KEY3_Pin))
			key=3;
		else if(!GPIO_ReadInputDataBit(JOY_A_KEY_Port,JOY_A_KEY_Pin))
			key=4;
		else if(!GPIO_ReadInputDataBit(JOY_B_KEY_Port,JOY_B_KEY_Pin))
			key=5;
		else if(!GPIO_ReadInputDataBit(JOY_C_KEY_Port,JOY_C_KEY_Pin))
			key=6;
		else if(!GPIO_ReadInputDataBit(JOY_D_KEY_Port,JOY_D_KEY_Pin))
			key=7;
		else if(!GPIO_ReadInputDataBit(JOY_CTR_KEY_Port,JOY_CTR_KEY_Pin))
			key=8;
		else
			key=0;

		switch(key)
		{
			case 1:
				GPIO_SetBits(LED4_Port , LED4_Pin);
				Delay(0xfffff);
				GPIO_ResetBits(LED4_Port , LED4_Pin);
				Delay(0xfffff);
				break;
			case 2:
				GPIO_SetBits(LED1_Port , LED1_Pin);
				Delay(0xfffff);
				GPIO_ResetBits(LED1_Port , LED1_Pin);
				Delay(0xfffff);
				break;
			case 3:
			  	GPIO_SetBits(LED2_Port , LED2_Pin);
			  	Delay(0xfffff);
			  	GPIO_ResetBits(LED2_Port , LED2_Pin);
			  	Delay(0xfffff);
				break;
			case 4:
				GPIO_SetBits(LED3_Port , LED3_Pin);
				Delay(0xfffff);
				GPIO_ResetBits(LED3_Port , LED3_Pin);
				Delay(0xfffff);
				break;
			case 5:
				GPIO_SetBits(LED1_Port , LED1_Pin);
			  	GPIO_SetBits(LED2_Port , LED2_Pin);
			  	GPIO_SetBits(LED3_Port , LED3_Pin);
			  	GPIO_SetBits(LED4_Port , LED4_Pin);
			  	Delay(0x4fffff);
			  	GPIO_ResetBits(LED1_Port , LED1_Pin);
			  	GPIO_ResetBits(LED2_Port , LED2_Pin);
			  	GPIO_ResetBits(LED3_Port , LED3_Pin);
			  	GPIO_ResetBits(LED4_Port , LED4_Pin);
			  	Delay(0xfffff);
				break;
			case 6:
				GPIO_SetBits(LED1_Port , LED1_Pin);
				Delay(0xfffff);
				GPIO_ResetBits(LED1_Port , LED1_Pin);
				
				GPIO_SetBits(LED2_Port , LED2_Pin);
				Delay(0xfffff);
				GPIO_ResetBits(LED2_Port , LED2_Pin);
				
				GPIO_SetBits(LED3_Port , LED3_Pin);
				Delay(0xfffff);
				GPIO_ResetBits(LED3_Port , LED3_Pin);
				
				GPIO_SetBits(LED4_Port , LED4_Pin);
				Delay(0xfffff);
				GPIO_ResetBits(LED4_Port , LED4_Pin);
				break;
			case 7:
				GPIO_SetBits(LED4_Port , LED4_Pin);
				Delay(0xfffff);
				GPIO_ResetBits(LED4_Port , LED4_Pin);
				
				GPIO_SetBits(LED3_Port , LED3_Pin);
				Delay(0xfffff);
				GPIO_ResetBits(LED3_Port , LED3_Pin);
				
				GPIO_SetBits(LED2_Port , LED2_Pin);
				Delay(0xfffff);
				GPIO_ResetBits(LED2_Port , LED2_Pin);
				
				GPIO_SetBits(LED1_Port , LED1_Pin);
				Delay(0xfffff);
				GPIO_ResetBits(LED1_Port , LED1_Pin);
				break;
			case 8:
				GPIO_SetBits(LED1_Port , LED1_Pin);
			  	GPIO_SetBits(LED2_Port , LED2_Pin);
			  	GPIO_SetBits(LED3_Port , LED3_Pin);
			  	GPIO_SetBits(LED4_Port , LED4_Pin);
			  	Delay(0xfffff);
			  	GPIO_ResetBits(LED1_Port , LED1_Pin);
			  	GPIO_ResetBits(LED2_Port , LED2_Pin);
			  	GPIO_ResetBits(LED3_Port , LED3_Pin);
			  	GPIO_ResetBits(LED4_Port , LED4_Pin);
			  	Delay(0x4fffff);
				break;
			default:
				GPIO_SetBits(LED1_Port , LED1_Pin);
			  	GPIO_SetBits(LED2_Port , LED2_Pin);
			  	GPIO_SetBits(LED3_Port , LED3_Pin);
			  	GPIO_SetBits(LED4_Port , LED4_Pin);
			  	Delay(0xfffff);
			  	GPIO_ResetBits(LED1_Port , LED1_Pin);
			  	GPIO_ResetBits(LED2_Port , LED2_Pin);
			  	GPIO_ResetBits(LED3_Port , LED3_Pin);
			  	GPIO_ResetBits(LED4_Port , LED4_Pin);
			  	Delay(0xfffff);
				break;
		}
  }

}

/*******************************************************************************
* Function Name  : GPIO_Configuration
* Description    : Configure GPIO Pin
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void GPIO_Configuration(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  RCC_APB2PeriphClockCmd(LED1_RCC_APB2Periph | LED2_RCC_APB2Periph | LED3_RCC_APB2Periph | LED4_RCC_APB2Periph, ENABLE);

  RCC_APB2PeriphClockCmd(KEY1_RCC_APB2Periph | KEY2_RCC_APB2Periph | KEY3_RCC_APB2Periph | JOY_A_KEY_RCC_APB2Periph |
							 JOY_B_KEY_RCC_APB2Periph |  JOY_C_KEY_RCC_APB2Periph |  JOY_D_KEY_RCC_APB2Periph |
							  JOY_CTR_KEY_RCC_APB2Periph, ENABLE); 						 
/**
 *  LED1 -> PB0 , LED2 -> PB1 , LED3 -> PB14 , LED4 -> PB15
 */					 
  GPIO_InitStructure.GPIO_Pin =  LED1_Pin;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 
  GPIO_Init(LED1_Port, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = LED2_Pin;
	GPIO_Init(LED2_Port, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = LED3_Pin;
	GPIO_Init(LED3_Port, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = LED4_Pin;
	GPIO_Init(LED4_Port, &GPIO_InitStructure);

	/* Key */
	GPIO_InitStructure.GPIO_Pin =  KEY1_Pin;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU; 
	GPIO_Init(KEY1_Port, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = KEY2_Pin;
	GPIO_Init(KEY2_Port, &GPIO_InitStructure);
	GPIO_InitStructure.GPIO_Pin = KEY3_Pin;
	GPIO_Init(KEY3_Port, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = JOY_A_KEY_Pin;
	GPIO_Init(JOY_A_KEY_Port, &GPIO_InitStructure);
	GPIO_InitStructure.GPIO_Pin = JOY_B_KEY_Pin;
	GPIO_Init(JOY_B_KEY_Port, &GPIO_InitStructure);
	GPIO_InitStructure.GPIO_Pin = JOY_C_KEY_Pin;
	GPIO_Init(JOY_C_KEY_Port, &GPIO_InitStructure);
	GPIO_InitStructure.GPIO_Pin = JOY_D_KEY_Pin;
	GPIO_Init(JOY_D_KEY_Port, &GPIO_InitStructure);
	GPIO_InitStructure.GPIO_Pin = JOY_CTR_KEY_Pin;
	GPIO_Init(JOY_CTR_KEY_Port, &GPIO_InitStructure);
}

/*******************************************************************************
* Function Name  : Delay
* Description    : Delay Time
* Input          : - nCount: Delay Time
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void  Delay (uint32_t nCount)
{
  for(; nCount != 0; nCount--);
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/*************************************** END OF FILE *************************************/
